#ifndef	KEY_MAX
    #define	KEY_MAX	    28		/* Double Define SCRN.H */
#endif

#define PRG_QUE     32

typedef struct _PP {
    struct _PP  *next;
    int         flg;
    int		copycnt;
    int		bits;
    char        *name;
    char        *make;
    char        *readme;
    char        *manual;
    char        *copy[16];
    char	*dir;
} PRGPTR;

typedef struct _KP {
    struct _KP  *next;
    struct _KP  *over;
    struct _KP  *grop;
    int		flg;
    char        *key;
    int         cnt;
    PRGPTR      *prog[PRG_QUE];
} KEYPTR;

extern int	prg_max;
extern int	key_max;
extern int	prg_cnt;
extern int	prg_hit;
extern int	prg_ofs;
extern PRGPTR	*prg_top;
extern KEYPTR   *key_tbl[];
extern PRGPTR   *prg_tbl[];

int	DB_init(char *file);
void	PRG_alldisp(int ofs);
void	KEY_cler(void);
void	KEY_clic(int no);
void	PRG_next(void);
void	PRG_back(void);
void	PRG_status(void);
